%   Saving of Relevant Workspace Data to Unique File Names
%   for Reconstruction Upon Analysis
%   Copyright 2008, 2009, 2010, 2011 George I. Evers.

%$%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Option to Automatically Save Each trial's workspace%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
DateString = datestr(now);
DateString(12) = '-';
DateString([15, 18]) = '.';
DateString(3) = [];
DateString(7) = [];
DateString(7) = [];
Internal_date_string_array_tr = [Internal_date_string_array_tr; DateString]; %stored to load file name
Rand_seq_start_point_array_tr = [Rand_seq_start_point_array_tr Rand_seq_start_point];
if Reg_Method == 1
    reg_fact_array_tr = [reg_fact_array_tr reg_fact];
end
if OnOff_MPSO
    if OnOff_func_evals % Give a unique and descriptive name to each file
        %saved (i) to prevent previous data in the same folder from being overwritten
        %and (ii) to identify in the filename the settings to which the data in the
        %file pertains, rather than requiring the user to load the data to know.
        if Reg_Method == 0
            if OnOff_NormR_stag_det
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            end
        else %(i.e. Regrouping case)
            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. Reg_Method == 2)
                if OnOff_NormR_stag_det
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end
                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end                                
                end
            end
        end
    else %i.e. if iterations are to be used instead of function evaluations
        if Reg_Method == 0
            if OnOff_NormR_stag_det
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end                                
            end
        else %(i.e. Regrouping case)
            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. Reg_Method == 2)
                if OnOff_NormR_stag_det
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end
                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end                                
                end
            end
        end
    end
else %i.e. MPSO inactive
    if OnOff_func_evals % Give a unique and descriptive name to each file
        %saved (i) to prevent previous data in the same folder from being overwritten
        %and (ii) to identify in the filename the settings to which the data in the
        %file pertains, rather than requiring the user to load the data to know.
        if Reg_Method == 0
            if OnOff_NormR_stag_det
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            end
        else %(i.e. Regrouping case)
            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. Reg_Method == 2)
                if OnOff_NormR_stag_det
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end
                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end                                
                end
            end
        end
    else %i.e. if iterations are to be used instead of function evaluations
        if Reg_Method == 0
            if OnOff_NormR_stag_det
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', ...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', ...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end                                
            end
        else %(i.e. Regrouping case)
            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                if OnOff_w_linear == 0
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                else
                    save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',', objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                        num2str(stag_thresh), ',', num2str(reg_fact),...
                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                        num2str(c1), ',', num2str(c2), ',',...
                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                        DateString, '.mat']);
                end
            else %(i.e. Reg_Method == 2)
                if OnOff_NormR_stag_det
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end
                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                    if OnOff_w_linear == 0
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    else
                        save(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_k_trials),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                            num2str(c1), ',', num2str(c2), ',',...
                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                            DateString, '.mat']);
                    end                                
                end
            end
        end
    end
end
clear DateString %Reduce workspace clutter by clearing this internally used variable once it has been used.