%   Loading of Relevant Workspace Data from Unique File Names for Analysis
%   Copyright 2008, 2009, 2010, 2011 George I. Evers.

%$%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Option to Load Each Trial's Workspace to Reconstruct Data Over Each Set of Trials%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if Reg_Method ~= 0
    if OnOff_k_after_each_grouping
        clear RegPSO_k_after_each_grouping %clear previous values before constructing data
    end
    if OnOff_fg_after_each_grouping
        clear RegPSO_fg_after_each_grouping %of the last trial's values
    end
    if OnOff_MPSO
        if OnOff_k_after_each_grouping
            clear MPSO_k_after_each_grouping %clear previous values before constructing data
        end
        if OnOff_fg_after_each_grouping
            clear MPSO_fg_after_each_grouping %of the last trial's values
        end
    end
    %Note: Upon adding other data here to be reconstructed, be sure to also
    %add it to "if OnOff_k_after_each_grouping || OnOff_fg_after_each_grouping || OnOff_g_after_each_grouping"
    %or "OnOff_fghist" currently around line 1048 in main.
end
for Internal_i = 1:num_trials
    DateString = Internal_date_string_array_tr(Internal_i, :); %Restore DateString used to save.
    Rand_seq_start_point = Rand_seq_start_point_array_tr(Internal_i);
    if Reg_Method == 1
        reg_fact = reg_fact_array_tr(Internal_i);
    end
    fg = fg_final_per_trial(1, Internal_i); %Restore function value used at save time.
    if OnOff_MPSO
        if OnOff_fghist
            if OnOff_func_evals
                if Reg_Method == 0
                    if OnOff_NormR_stag_det
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end
                    else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end                                
                    end
                else %(i.e. Regrouping case)
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                end
                            end
                        else %i.e. ~OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. ~OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            else %i.e. if iterations are to be used instead of function evaluations
                if Reg_Method == 0
                    if OnOff_NormR_stag_det
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end
                    else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end                                
                    end
                else %(i.e. Regrouping case)
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            end
        else %(i.e. OnOff_fghist ~= 1)
            if OnOff_func_evals
                if Reg_Method == 0
                    %There are currently no parameters loaded in the standard case when OnOff_fghist == 0.  The code is left as a placeholder to later load other data in the future.
                    if OnOff_NormR_stag_det
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end
                    else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end                                
                    end
                else %(i.e. Regrouping case)
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping', 'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping', 'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', 'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', 'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            else %i.e. if iterations are to be used instead of function evaluations
                if Reg_Method ~= 0
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping', ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'MPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'MPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'MPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat']);
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat']);
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/MPSORM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            end
        end
    else %i.e. MPSO inactive
        if OnOff_fghist
            if OnOff_func_evals
                if Reg_Method == 0
                    if OnOff_NormR_stag_det
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end
                    else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end                                
                    end
                else %(i.e. Regrouping case)
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping', ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping', ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            else %i.e. if iterations are to be used instead of function evaluations
                if Reg_Method == 0
                    if OnOff_NormR_stag_det
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end
                    else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'], 'fghist');
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end                                
                    end
                else %(i.e. Regrouping case)
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. ~OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping', 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %i.e. ~OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. ~OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'fghist_current_trial');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'fghist_current_trial');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end %temporary ending marker
                end
            end
        else %(i.e. OnOff_fghist ~= 1)
            if OnOff_func_evals
                if Reg_Method == 0
                    %There are currently no parameters loaded in the standard case when OnOff_fghist == 0.  The code is left as a placeholder to later load other data in the future.
                    if OnOff_NormR_stag_det
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(stag_thresh), ',', ...
                                num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end
                    else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                        if OnOff_w_linear == 0
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        else
                            TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat']);
                            if OnOff_Autodelete_Trial_Data
                                delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                num2str(np), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                num2str(c1), ',', num2str(c2), ',',...
                                num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                ',', num2str(Rand_seq_start_point), ',', ...
                                num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                DateString, '.mat'])
                            end
                        end                                
                    end
                else %(i.e. Regrouping case)
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping', 'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping', 'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', 'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', 'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_FEs_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            else %i.e. if iterations are to be used instead of function evaluations
                if Reg_Method ~= 0
                    if OnOff_k_after_each_grouping
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping', ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], 'RegPSO_k_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    else %(i.e. ~OnOff_k_after_each_grouping)
                        if OnOff_fg_after_each_grouping
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'], ...
                                        'RegPSO_fg_after_each_grouping');
                                    if OnOff_Autodelete_Trial_Data
                                        delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat'])
                                    end
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'], ...
                                            'RegPSO_fg_after_each_grouping');
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        else %i.e. OnOff_fg_after_each_grouping == 0
                            if Reg_Method == 1 %which implies for now that OnOff_NormR_stag_det == 1
                                if OnOff_w_linear == 0
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat']);
                                else
                                    TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',', objective(1:2), ',', num2str(dim), ',', ...
                                        num2str(np), ',',num2str(stag_thresh), ',', num2str(reg_fact),...
                                        ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                        num2str(c1), ',', num2str(c2), ',',...
                                        num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                        ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                        num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                        DateString, '.mat']);
                                end
                            else %(i.e. Reg_Method == 2)
                                if OnOff_NormR_stag_det
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', ...
                                            num2str(np), ',',num2str(stag_thresh), ',', num2str(num_runs_b4_reduction), ',', ...
                                            num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end
                                else %(i.e. OnOff_NormR_stag_det ~=1 and presumably == 0, in which case "stag_thresh" is removed from the filename)
                                    if OnOff_w_linear == 0
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',', num2str(OnOff_w_linear), ',', num2str(w),...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    else
                                        TrialDataCarrier = load(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat']);
                                        if OnOff_Autodelete_Trial_Data
                                            delete(['Data/', DateString_dir, '/WS/RM', num2str(Reg_Method), 'Tr', num2str(Internal_i),',',  objective(1:2), ',', num2str(dim), ',', num2str(np), ',',...
                                            num2str(num_runs_b4_reduction), ',', num2str(vmax_perc), ',', num2str(OnOff_v_clamp), ',', num2str(OnOff_v_reset), ',',...
                                            num2str(c1), ',', num2str(c2), ',',...
                                            num2str(OnOff_w_linear), ',', num2str(w_i), ',', num2str(w_f)...
                                            ',', num2str(Rand_seq_start_point), ',', num2str(max_num_groupings), ',',...
                                            num2str(num_trials), ',Fm', num2str(max_iter_per_grouping), ',', num2str(fg), ',',...
                                            DateString, '.mat'])
                                        end
                                    end                                
                                end
                            end
                        end
                    end
                end
            end
        end
    end
    if Reg_Method == 0
        if OnOff_fghist
            fghist_over_all_trials(Internal_i, 1:length(TrialDataCarrier.fghist)) = TrialDataCarrier.fghist;
        end
    else %(i.e. Regrouping case)
        if (Reg_Method == 1)
            if OnOff_fghist
                fghist_over_all_trials(Internal_i, 1:length(TrialDataCarrier.fghist_current_trial)) = TrialDataCarrier.fghist_current_trial;
                    %not yet working for case Reg_Method == 2 since a matrix can't be stored
                    %to a row, but the data should correctly be stored in TrialDataCarrier.
            end
        end
        if OnOff_MPSO %Convert histories over 1 trial to a matrix of histories over all trial
            if OnOff_k_after_each_grouping
                MPSO_k_after_each_grouping	(Internal_i, 1:length(TrialDataCarrier.MPSO_k_after_each_grouping)) = TrialDataCarrier.MPSO_k_after_each_grouping;
            end
            if OnOff_fg_after_each_grouping
                MPSO_fg_after_each_grouping(Internal_i, 1:length(TrialDataCarrier.MPSO_fg_after_each_grouping)) = TrialDataCarrier.MPSO_fg_after_each_grouping;
            end
        else %i.e. if ~OnOff_MPSO
            if OnOff_k_after_each_grouping
                RegPSO_k_after_each_grouping(Internal_i, 1:length(TrialDataCarrier.RegPSO_k_after_each_grouping)) = TrialDataCarrier.RegPSO_k_after_each_grouping;
            end
            if OnOff_fg_after_each_grouping
                RegPSO_fg_after_each_grouping(Internal_i, 1:length(TrialDataCarrier.RegPSO_fg_after_each_grouping)) = TrialDataCarrier.RegPSO_fg_after_each_grouping;
            end
        end
    end
    clear TrialDataCarrier %free memory & reduce workspace clutter
end
clear Internal_i Internal_date_string_array_tr Rand_seq_start_point_array_tr reg_fact_array_tr %Clear to reduce workspace clutter